package fr.faraphel.m1_pe_kafka

import org.apache.kafka.clients.producer.KafkaProducer
import org.apache.kafka.clients.producer.ProducerConfig
import org.apache.kafka.clients.producer.ProducerRecord
import java.util.Properties


/**
 * The producer
 */
class Producer {
    private val properties: Properties = Properties()
    private var producer: KafkaProducer<String, String>
    private val topic: String = "Température_Celsius"

    init {
        this.properties[ProducerConfig.BOOTSTRAP_SERVERS_CONFIG] = "localhost:9092"
        this.properties[ProducerConfig.KEY_SERIALIZER_CLASS_CONFIG] = "org.apache.kafka.common.serialization.StringSerializer"
        this.properties[ProducerConfig.VALUE_SERIALIZER_CLASS_CONFIG] = "org.apache.kafka.common.serialization.StringSerializer"
        this.producer = KafkaProducer(properties)
    }

    fun main() {
        while (true) {
            // create a new record
            val record: ProducerRecord<String, String> = ProducerRecord(this.topic, "bonjour el mundo")
            // send the record
            this.producer.send(record)
            this.producer.flush()
        }
    }
}
