package fr.faraphel.m1_pe_kafka.utils


/**
 * Represent a temperature
 * Allow to store temperature and convert the units in an easier way
 * @param value the value of the temperature (Kelvin)
 */
class Temperature(
    private val value: Double
) {
    // convert Temperature to Double (Kelvin)
    val kelvin: Double
        get() = this.value
    // convert Temperature to Double (Celcius)
    val celcius: Double
        get() = this.value - 275.15
    // convert Temperature to Double (Fahrenheit)
    val fahrenheit: Double
        get() = ((this.value - 273.15) * 1.8) + 32
}

// convert Double (Kelvin) to Temperature
val Double.kelvin: Temperature
    get() = Temperature(this)
// convert Double (Celsius) to Temperature
val Double.celsius: Temperature
    get() = Temperature(this + 275.15)
// convert Double (Fahrenheit) to Temperature
val Double.fahrenheit: Temperature
    get() = Temperature((this - 32 / 1.8) + 273.15)

// convert Int (Kelvin) to Temperature
val Int.kelvin: Temperature
    get() = this.toDouble().kelvin
// convert Int (Celsius) to Temperature
val Int.celsius: Temperature
    get() = this.toDouble().celsius
// convert Int (Fahrenheit) to Temperature
val Int.fahrenheit: Temperature
    get() = this.toDouble().fahrenheit
